version: "0.5"

processes:
  ## Serviço para o servidor do bikesp
  ## Inicia o banco de dados e o servidor Flask em modo de desenvolvimento
  ## Encerra ambos ao finalizar o processo
  ## Executa em modo desanexado
  servidor:
    working_dir: "${DEVBOX_PROJECT_ROOT}/servidor"
    log_location: "${DEVBOX_PROJECT_ROOT}/.devbox/logs/servidor.log"
    depends_on:
      banco: 
       condition: process_healthy
    command: |
      flask --app bikespserver vite build
      flask --app bikespserver run --reload --debugger --host=0.0.0.0 --port=8000
    shutdown:
      command: "devbox services stop banco"
    ready_log_line: "Running on"

  ## Serviço para o banco de dados
  banco:
    command: "pg_ctl start -o \"-k $PGHOST -p $BD_PORT\""
    is_daemon: true
    shutdown: 
      command: "pg_ctl stop -m fast"
    availability:
      restart: "always"
    readiness_probe:
      exec:
        command: "pg_isready"

  ## Serviço para o servidor backend de teste
  servidor-teste:
    working_dir: "${DEVBOX_PROJECT_ROOT}/servidor"
    log_location: "${DEVBOX_PROJECT_ROOT}/.devbox/logs/servidor.log"
    depends_on:
      banco: 
       condition: process_healthy
    command: |
      flask --app bikespserver vite build
      flask --app bikespserver run --reload --debug --host=0.0.0.0 --port=${SERVER_PORT_TESTE}
    shutdown:
      command: "devbox services stop banco"
    ready_log_line: "Running on"

  ## Logger interno do process-compose, apenas para uso na TUI
  pc_log:
    command: "tail -f -n100 process-compose-${USER}.log"
    working_dir: "/tmp"